xmlControl = {
    
        xmlDoc: {},
    
        readXML: function(xml) {
            $.get(xml, function (xmlDoc){
                xmlControl.xmlDoc = xmlDoc;
                xmlControl.firstStep();
            });
    
        },
    
        init: function(xml) {
             xmlControl.readXML(xml);
        },
    
        getConfiguration: function() {
            return xmlControl.xmlDoc.getElementsByTagName('configuration');
        },
    
        firstStep: function() {
            configuration = xmlControl.getConfiguration();
            stepOne = configuration[0].getElementsByTagName('start-node')[0].id;
    
            $('#btn-home').data('step', stepOne);
            xmlControl.executeStep(xmlControl.findStep(stepOne),0);
        },
    
        findStep: function(id) {
            xmlDoc = xmlControl.xmlDoc;
    
            nodeDecision = xmlDoc.getElementsByTagName('node-decisions');
            nodeChild = nodeDecision[0].getElementsByTagName('node-decision');
    
            bFound = false;
            iCount = 0;
            for (iCount = 0; iCount < nodeChild.length; iCount++) {
                nodeElement = nodeChild[iCount];
                if (nodeElement.id == id)
                    break;
            }
            return nodeChild[iCount];
        },
    
        removebtns: function(div, numBtns){
            for(i=0; i<numBtns; i++){
                div.removeChild(document.getElementById("btn"+i));
            }
        },
    
        addBtns: function(div, btns, numBtns){
    
            for(i=0; i<numBtns; i++){
                var aTag = document.createElement('a');
                aTag.id="btn"+i;
                aTag.setAttribute('href',"#");
                
                aTag.innerHTML = btns[i].textContent;
                aTag.className="btn btn-control";
                div.appendChild(aTag);
            }
        },
    
    
        linkButtons:function(states, numStates){
            for(i=0; i<numStates; i++){
                $('#btn'+i).data('step', states[i].id).removeClass('disabled');
                $('#btn'+i).click(function() {
                    xmlControl.executeStep(xmlControl.findStep($(this).data('step')),numStates);
                });
            }
            $('#btn-home').click(function() {
                    xmlControl.executeStep(xmlControl.findStep($(this).data('step')),numStates);
            });
        },
        
        sendState:function(component){
            var currentState = component.getAttribute("data-step");
            xmlControl.executeStep(xmlControl.findStep(currentState),numStates);
            // console.log(currentState);
            
            var currentId = component.getAttribute("id");
            ids.push(currentId);
            localStorage.setItem("ids", ids);
        },
    
        executeStep: function(xmlDocStep, pastStates) {
            var div = document.getElementById('controls');
            states = xmlDocStep.getElementsByTagName('state');
            numStates=states.length;
            
            xmlControl.removebtns(div,pastStates);
            xmlControl.addBtns(div, states, numStates);
            xmlControl.linkButtons(states, numStates);
    
    
            elements = xmlDocStep.getElementsByTagName('elements');
            
            canvas = elements[0].getElementsByTagName('canvas');
            $('.canvas').html(canvas[0].childNodes[0].nodeValue);

            //Alter Image
            // image = elements[0].getElementsByTagName('image');
    
            // $('.col-img img').attr('src', image[0].childNodes[0].nodeValue);
            //Alter Image - End
    
            //Alter Text
            // text = elements[0].getElementsByTagName('text');
            // title = text[0].getElementsByTagName('title');
    
            // $('.col-apresentation .title').html(title[0].childNodes[0].nodeValue);
    
            // subtitle = text[0].getElementsByTagName('subtitle');
            // $('.col-apresentation .description').html(subtitle[0].childNodes[0].nodeValue);
    
            //Alter Text - End
    
            //Control
            controls = elements[0].getElementsByTagName('controls');
            link = controls[0].getElementsByTagName('link');
        }
    };

  